%% Author: Wouter Verbeke
% Data Analytics Laboratory
% Department of Business Technology and Operations 
% Faculty of Economic and Social Sciences and Solvay Business School
% Vrije Universiteit Brussel, Pleinlaan 2, B-1050 Brussel, Belgium

%% Documentation
% This function counts the number of tests per rule in a ruleset

function nrTestsRule = countTestsRuleset(ruleset,defaultRule,varType, adjValue)

if nargin < 4
    adjValue = 0;
end

nrTestsRule = zeros(size(ruleset,1),1);
for i = 1:size(ruleset,1)
    varIndex = 1;
    diffRule = ruleset(i,:)-defaultRule;
    for j = 1:size(varType,2)
        if varType(1,j) == 0
            if (abs(diffRule(1,varIndex)) > 0 + adjValue)
                nrTestsRule(i,1) = nrTestsRule(i,1) + 1;
            end
            varIndex = varIndex + 1;
        else
            if (abs(diffRule(1,varIndex)) > 0 + adjValue) || (abs(diffRule(1,varIndex+1)) > 0 + adjValue)
                nrTestsRule(i,1) = nrTestsRule(i,1) + 1;
            end
            varIndex = varIndex + 2;
        end
    end
end