% k = fn_arff2struct(orFilename)
% Thomas Verbraken - 04/05/2010 - Katholieke Universiteit Leuven

% Takes a discretized arff file from weka and converts it to a file where 
% the strings are replaced by nominal variables = {0 .. |val|}
% output is a struct variable
function k = fn_arff2struct(orFilename)
% load data
wekaOBJ = loadARFF(orFilename);
[M,featureNames,~,stringVals,~] = weka2matlab(wekaOBJ,[]);
M_new = nan(size(M));
stringVals_new = cell(size(stringVals));
k = struct('data',[],'dom_counts',[],'mapping',cell(0),'names',cell(0));
k(1).names = featureNames;
for j=1:size(M,2)
    if isempty(stringVals{j})
        attr_val = sort(unique(M(:,j)));
        for n=1:length(attr_val)
            M_new(M(:,j)==attr_val(n),j) = n-1;
        end
        stringVals_new{j} = attr_val;
        k(1).dom_counts(j) = length(attr_val);
    else
        M_new(:,j) = M(:,j);
        stringVals_new{j} = stringVals{j};
        k(1).dom_counts(j) = length(stringVals{j});
    end
end
k(1).mapping = stringVals;
k(1).data = M_new;
if sum(isnan(M_new))>0
    warning(' NaN in new data matrix');
end

