% fn_convert_num2nom(orFilename,newFilename,conv_attr)
% Thomas Verbraken - 03/29/2010 - Katholieke Universiteit Leuven
%
% This file takes an arff file as input and converts it to a csv file with
% the same name.

function fn_convert_arff2xls(orFilename)
%% training set
wekaOBJ = loadARFF(orFilename);
[allData,featureNames,~,stringVals,~] = weka2matlab(wekaOBJ,[]);
output = {};
% -----------
% idx_strat = fn_stratSample(allData(:,end),frac*size(allData,1));
% allData = allData(idx_strat,:);
%------------

for i=1:length(featureNames)
    if isempty(stringVals{i})
        output = [output num2cell(allData(:,i))];
    else
        output = [output stringVals{i}(allData(:,i)+1)];
    end
end
% replace featureNames with 'V1', 'V2', ... and write a 'translation file
% named [datasetname  '_mapping.xls']
featureNames2 = cell(size(featureNames));
for j=1:length(featureNames2)
    featureNames2{j} = ['V' num2str(j)];
end
output = [featureNames2;output];
idx_arff = strfind(orFilename,'.arff');
xlswrite([orFilename(1:idx_arff-1) '.xls' ],output);
% store the mapping
fname_map = [orFilename(1:idx_arff-1) '_mapping.xls' ];
map = [featureNames2' featureNames'];
xlswrite(fname_map,map);