% function fn_orderAttr(orFilename,newFilename)
% Thomas Verbraken - 04/13/2010 - Katholieke Universiteit Leuven
%
% This function loads an arff file and orders the variables so that the
% class variable comes on the last place and the remaining variables are
% ordered with decreasing univariate correlation with the class variable
% (from position 1 to end-1).


function fn_orderAttr(orFilename_trn,newFilename_trn,orFilename_tst,newFilename_tst)
% TRAINING SET: load data and order
wekaOBJ = loadARFF(orFilename_trn);
[data,featureNames,targetIdx,~,relName] = weka2matlab(wekaOBJ,[]);
corr = abs(corrcoef(data));
corr = corr(:,targetIdx);
[~,idx] = sort(corr,'descend');
idx = [idx(2:end)' idx(1)'];
data = data(:,idx);
featureNames = featureNames(idx);
wekaOBJ = matlab2weka([relName '.sorted'], featureNames, data,targetIdx);
idx_arff = strfind(newFilename_trn,'.arff');
saveARFF([newFilename_trn(1:idx_arff-1) '_TEMP.arff'],wekaOBJ);
% TEST SET: load data and apply same ordering as test set
wekaOBJ = loadARFF(orFilename_tst);
[data,featureNames,targetIdx,~,relName] = weka2matlab(wekaOBJ,[]);
data = data(:,idx);
featureNames = featureNames(idx);
wekaOBJ = matlab2weka([relName '.sorted'], featureNames, data,targetIdx);
idx_arff = strfind(newFilename_tst,'.arff');
saveARFF([newFilename_tst(1:idx_arff-1) '_TEMP.arff'],wekaOBJ);
fn_convert_num2nom([newFilename_trn(1:idx_arff-1) '_TEMP.arff'],newFilename_trn,1:size(data,2),[newFilename_tst(1:idx_arff-1) '_TEMP.arff'],newFilename_tst)


