% function sample = stratSample(y,k)
% Thomas Verbraken - 03/29/2010 - Katholieke Universiteit Leuven
%
% This function takes as input a Nx1 vector of class labels and a number of
% k which defines the number of instances in the sample. It then samples 
% from the full dataset while conserving the class distribution. The 
% output is a array with indices.


function sample = fn_stratSample(y,k)
if k>length(y)
    error('Misspecification of k: k>y');
end
% define the different class labels
attr_val = unique(y);
if size(y,1) > 1
    y = y';
end
% Sample from the distribution with preservation of class distribution
sample = [];
for i=1:length(attr_val)
    idx = find(y==attr_val(i));
    ki = round(length(idx)/length(y)*k);
    idx_rdm = randsample(length(idx),ki);
    sample = [sample idx(idx_rdm)];
end