cutoff = 0.6;

[C,N] = Weka_Logit_Coef;
D = Weka_Logit_Data;

N_Cum = [1 N];
for i = 1:size(N,2)
    N_Cum(1,i+1) = N_Cum(1,i) + N(1,i);
end


P = zeros(size(D,1),1);

for i = 1:size(D,1)
    for j = 1:size(D,2)-1
        if N(1,j) == 1
            P(i) = P(i) + C(N_Cum(j),1);%*D(i,j);
        else
            P(i) = P(i) + C(N_Cum(j)+D(i,j),1);%*D(i,j);
        end
    end
    P(i) = P(i) + C(size(C,1),1); 
end

for i = 1:size(P)
    P(i) = 1/(1+exp(-P(i)));
end

Class = P;

for i = 1:size(P)
    if P(i)>cutoff
        Class(i) = 0;
    else
        Class(i) = 1;
    end
end

Comp = D(:,size(D,2)) - Class;
countpos = 0;
classpos = 0;
classneg = 0;
countneg = 0;
faultneg = 0;
faultpos = 0;
total = size(Class,1);

for i = 1:size(D,1)
    if D(i,size(D,2)) == 1
        countpos = countpos + 1;
    end 
    if Class(i) == 1
        classpos = classpos +1;
    end
    if Class(i) == 0
        classneg = classneg +1;
    end
    if D(i,size(D,2)) == 0
        countneg = countneg + 1;
    end
    if Comp(i) == -1
        faultpos = faultpos + 1;
    end
    if Comp(i) == 1
        faultneg = faultneg + 1;
    end
end

sens = (classpos - faultpos) / countpos;
spec = (classneg - faultneg) / countneg;
acc = ((classpos - faultpos) + (classneg - faultneg)) / total;

        