% fn_convert_num2nom(orFilename,newFilename,conv_attr)
% Thomas Verbraken - 03/29/2010 - Katholieke Universiteit Leuven
%
% This file takes an arff file as input and converts those variables 
% defined in conv_attr from numeric variables to nominal variables. To
% create the header part in the arff file, the function automatically
% checks in the data which possible values the nominal attribute can take.

function fn_convert_num2nom(orFilename,newFilename)%,conv_attr,orFilename_tst,newFilename_tst)

%% Connect to weka and load file
wekaOBJ = loadARFF(orFilename);
[allData,~,~,~,~] = weka2matlab(wekaOBJ,[]);
%% is there a test set supplied?
if nargin>3
    tst = 1;
else
    tst = 0;
end
%% load text files
txt_read = fopen(orFilename,'r');
txt_write = fopen(newFilename,'w');
if tst
    tst_read = fopen(orFilename_tst,'r');
    tst_write = fopen(newFilename_tst,'w');
end
% read first two lines and write in target file
countChar = 0;
L = fgetl(txt_read);
countChar = countChar + length(L) + 1;
fprintf(txt_write,'%s\n',L);
if tst, fprintf(tst_write,'%s\n',L); end
L = fgetl(txt_read);
countChar = countChar + length(L) + 1;
fprintf(txt_write,'%s\n',L);
if tst, fprintf(tst_write,'%s\n',L); end
% read each line and convert to nominal if necessary
display('Ik neem voetstoots aan dat Thomas zijn m-file werkt, wat een grenzeloos vertrouwen!');
for i = 1:size(allData,2)
    L = fgetl(txt_read);
    countChar = countChar + length(L) + 1;
    % if the attribute is in the conv_attr list and if the attribute is
    % currently numerical, convert the "numeric" in the text string to
    % {0,1,...} as needed
    if i ==size(allData,2)% 1 %sum(conv_attr==i) == 1
        attr = sort(intersect(allData(:,i),allData(:,i)));
        pos_num = strfind(L,'numeric');
        if isempty(pos_num)
            warning(['Attribute number ' int2str(i) ' is not a numeric attribute']) 
        else
            str_nominal = '{';
            for n = 1:length(attr)
                str_nominal = [str_nominal  int2str(attr(n)) ','];
            end
            str_nominal = [str_nominal(1:end-1) '}'];
            L = [L(1:pos_num-1) str_nominal];
        end
    end
    % write the (modified) string in the target file
    fprintf(txt_write,'%s\n',L);
    if tst, fprintf(tst_write,'%s\n',L); end
end
% training set data
wholeFile = textread(orFilename, '%s','bufsize',70000000, 'whitespace', '');
L = wholeFile{1};
L = L(countChar+1:end);
fprintf(txt_write,'%s',L);
% test set data
if tst
    wholeFile = textread(orFilename_tst, '%s','bufsize',70000000, 'whitespace', '');
    L = wholeFile{1};
    countChar = strfind(L,'@data');
    fprintf(tst_write,'%s',L(countChar-1:end));
end
fclose('all');
