%% Thomas Verbraken - 03/10/2010 - Katholieke Universiteit Leuven

%% This file takes an arff file as input and converts those variables 
%% defined in "conv_attr" from numeric variables to nominal variables. It
%% checks in the arff file which nominal values it can take (the values
%% between {..}).

function fn = fn_convert_num2nom(orFilename,newFilename,conv_attr)
% orFilename = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell_v0.xx.arff';
% make sure to create a file with this name already. Be careful, Matlab
% will overwrite anything within this file!!!
% newFilename = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell_v0.xx.arff';
% numbers of the attributes which need to be converted
% conv_attr = [25	33	34	35	36	37	38	39	40	41	42	43	44	45	46	47	50	51	53	55	57	59	61];

%% Connect to weka and load file
% path = 'c:\Program Files (x86)\Weka-3-6\weka.jar';
% javaaddpath(path);
% path = 'c:\users\thomas\Documents\MATLAB\Wouter - Matlab\Clustering\Matlab Clustering Package v.2';
% path2 = 'c:\users\thomas\Documents\MATLAB\Wouter - Matlab\';
% path3 = 'C:\Users\Thomas\Documents\MATLAB\Wouter - MATLAB\matlab2weka\';
% addpath(path,path2,path3);
wekaOBJ = loadARFF(orFilename);
[allData,featureNames,targetNDX,stringVals,relationName] = weka2matlab(wekaOBJ,[]);

%% load text files
txt_read = fopen(orFilename,'r');
txt_write = fopen(newFilename,'w');
% read first two lines and write in target file
countChar = 0;
L = fgetl(txt_read);
countChar = countChar + length(L) + 1;
fprintf(txt_write,'%s\n',L);
L = fgetl(txt_read);
countChar = countChar + length(L) + 1;
fprintf(txt_write,'%s\n',L);
% read each line and convert to nominal if necessary
for i = 1:size(allData,2)
    L = fgetl(txt_read);
    countChar = countChar + length(L) + 1;
    % if the attribute is in the conv_attr list and if the attribute is
    % currently numerical, convert the "numeric" in the text string to
    % {0,1,...} as needed
    if sum(conv_attr==i) == 1
        attr = sort(intersect(allData(:,i),allData(:,i)));
        pos_num = strfind(L,'numeric');
        if isempty(pos_num)
            L = L;
            warning(['Attribute number ' int2str(i) ' is not a numeric attribute']) 
        else
            str_nominal = '{';
            for n = 1:length(attr)
                str_nominal = [str_nominal  int2str(attr(n)) ','];
            end
            str_nominal = [str_nominal(1:end-1) '}'];
            L = [L(1:pos_num-1) str_nominal];
        end
    end
    % write the (modified) string in the target file
    fprintf(txt_write,'%s\n',L);
end
wholeFile = textread(orFilename, '%s','bufsize',100000000, 'whitespace', '');
L = wholeFile{1};
L = L(countChar+1:end);
fprintf(txt_write,'%s',L);
fn = fclose('all');



        
        


