%% function oversampleArff
%% Wouter Verbeke - 10/02/2010 - K.U.Leuven - FEB - LIRIS
%% function oversampleArff oversamples a data set in an .arff file to
%% approximate a desired distribution, and writes the data back to an 
%% .arff file

%% TODO: saveARFF does not copies variable information to new file!!
homeFolder = 'C:\My\Documents\Churn Benchmarking\Data\Mobistar\';
inputFile = 'Mobistar.Train.Var50.arff';
outputFile = 'Korea5.Train.Var50.Oversampled.arff';
wekaOBJ = loadARFF(strcat(homeFolder, inputFile));
[data,featureNames,targetNDX,stringVals,relationName] = weka2matlab(wekaOBJ);
clear wekaOBJ targetNDX stringVals
oneIndices = find(data(:,end)==1);
zeroIndices = find(data(:,end)==0);

% desired percentage, or directly number of times to oversample one-class
onePercentage = 50/100;
nrZeroPresent = size(zeroIndices,1);
nrOnePresent = size(oneIndices,1);
times = round(nrZeroPresent/nrOnePresent)-1;
oversampledData = oversample(data,times);
wekaOBJ = matlab2weka(relationName, featureNames,oversampledData);
saveARFF(strcat(homeFolder, outputFile),wekaOBJ);
