% Script to run all the datapreparation for Cell2Cell
% See more information in the excel spreadsheet with all steps explained

%% set path
path = 'c:\Program Files (x86)\Weka-3-6\weka.jar';
javaaddpath(path);
path2 = 'c:\users\thomas\Documents\MATLAB\Wouter - Matlab\';
path3 = 'C:\Users\Thomas\Documents\MATLAB\Wouter - MATLAB\matlab2weka\';
addpath(path,path2,path3);
%% Step 1
% redefine certain variables and load the file in Weka

%% Step 2
% Convert from num to nom
conv_attr = [25	32	33	34	35	36	37	38	39	40	41	42	43	44	45	46	47	50	51	53	55	57	59	60	61];
orFilename = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.1.arff';
newFilename = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.2.arff';
fn_convert_num2nom(orFilename,newFilename,conv_attr)
% remove calibrat and customer (29,60)
wekaOBJ = loadARFF(newFilename);
filter = javaObject('weka.filters.unsupervised.attribute.Remove');
filter.setOptions({'-R' '29,60'});
filter.setInputFormat(wekaOBJ);
wekaOBJ = filter.useFilter(wekaOBJ, filter);
saveARFF(newFilename,wekaOBJ);
    
%% Step 3
% Split in test and training set
orFilename = 'C:\My\Documents\Start\Data\Start.v.0.6.arff';
newFilename = 'C:\My\Documents\Start\Data\Start.v.0.7.arff';
[allData_trn,allData_tst,featureNames,stringVals,nom_type] = fn_splitDataset(orFilename,.66,1,newFilename);

%% Step 4
% Median and mode imputation
[allData_trn,allData_tst,missVal] = fn_replaceMissing_fromMAT(allData_trn,allData_tst,stringVals);


%% Step 5
% Clustering coarse variables
newFilename_trn = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.5_trn.arff';
newFilename_tst = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.5_tst.arff';
nrVariable_array = [25];
nrClusters_array = [4];
csv_outputnames{1} = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\clusters_csa.csv';

[allData_trn_clust,allData_tst_clust,clust] = fn_cluster(allData_trn,allData_tst,nrVariable_array,nrClusters_array,csv_outputnames,newFilename_trn,newFilename_tst,stringVals,featureNames);

%% Step 6
% Discretization
orFilename_trn = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.5_trn.arff';
orFilename_tst = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.5_tst.arff';
newFilename_trn = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.6_trn.arff';
newFilename_tst = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.6_tst.arff';
stringVals = fn_discrFayyad(orFilename_trn,newFilename_trn,orFilename_tst,newFilename_tst);
save 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\discretization_stringVals' stringVals

%% Step 7
% oversampling - not for BN

%% Step 8
% Final file
orFilename_trn = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.6_trn.arff';
orFilename_tst = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v0.6_tst.arff';
finalFilename_trn = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v1.0_trn.arff';
finalFilename_tst = 'C:\Users\Thomas\Documents\KUL\Raw Data\Churn Data - Thomas\Cell2Cell\Cell2Cell_v1.0_tst.arff';
fn_orderAttr(orFilename_trn,finalFilename_trn,orFilename_tst,finalFilename_tst);




