%% function sampleArff
%% Wouter Verbeke - 10/02/2010 - K.U.Leuven - FEB - LIRIS
%% function sampleArff samples a data set in an .arff file to a specified
%% distribution, and writes the data back to an .arff file

%% TODO: saveARFF does not copies variable information to new file!!
homeFolder = 'Y:\Churn Benchmarking\Data\All Inputfiles\';
inputFile = 'Korea5.v.1.arff';
outputFile = 'Korea5.v.2.noSample.arff';

wekaOBJ = loadARFF(strcat(homeFolder, inputFile));
[data,featureNames,targetNDX,stringVals,relationName] = weka2matlab(wekaOBJ);
clear wekaOBJ targetNDX stringVals

oneIndices = find(data(:,end)==1);
zeroIndices = find(data(:,end)==0);

% desired percentage, or directly desired number of instances of class 1
onePercentage = 5/100;
nrZeroPresent = size(zeroIndices,1);
nrOneDesired = round((onePercentage*nrZeroPresent)/(1-onePercentage));

oneData = shuffle(data(oneIndices,:));
newData = shuffle([oneData(1:nrOneDesired,:);data(zeroIndices,:)]);

wekaOBJ = matlab2weka(relationName, featureNames,newData);
saveARFF(strcat(homeFolder, outputFile),wekaOBJ);
