%% function stratifiedSampleArff

%% Wouter Verbeke - 10/02/2010 - K.U.Leuven - FEB - LIRIS
%% function creates stratified sample of an .arff data set 
%% and writes the data back to an .arff file (stratified: with original
%% distribution of class variable)

%% TODO: saveARFF does not copies variable information to new file!!

% Name of the original arff file, and name of the outputfile
homeFolder = 'Y:\Churn Benchmarking\Data\All Inputfiles\';
inputFile = 'Mobistar.Train.Var20.arff';
outputFile = 'Mobistar.Train.Var20.Sample1000.arff';
% Desired size of the stratified sample
sampleSize = 1000;
wekaOBJ = loadARFF(strcat(homeFolder, inputFile));
[data,featureNames,targetNDX,stringVals,relationName] = weka2matlab(wekaOBJ);
clear wekaOBJ targetNDX stringVals
oneIndices = find(data(:,end)==1);
zeroIndices = find(data(:,end)==0);

% desired percentage, or directly desired number of instances of class 1
nrObservations = size(data,1);
if nrObservations < sampleSize
    disp('demanded sample size is larger than original data set - original set saved as sample');
    wekaOBJ = matlab2weka(relationName, featureNames,newData);
    saveARFF(strcat(homeFolder, outputFile),wekaOBJ);
else
    nrOneObservations = size(oneIndices,1);
    onePercentage = nrOneObservations/nrObservations;
    nrOneDesired = round(onePercentage*sampleSize);

    % create new dataset - no variable should have variance = 0 - and write to arff
    allVarsOK = 0;
    while allVarsOK ~= 1
        oneData = shuffle(data(oneIndices,:));
        zeroData = shuffle(data(zeroIndices,:));
        newData = shuffle([oneData(1:nrOneDesired,:);zeroData(1:(sampleSize-nrOneDesired),:)]);
        V = var(newData).^(0.5);
        Z = find(V==0);
        if isempty(Z) == 1
            allVarsOK = 1;
        else
            disp('iteration not ok..');
        end
    end
    wekaOBJ = matlab2weka(relationName, featureNames,newData);
    saveARFF(strcat(homeFolder, outputFile),wekaOBJ);
end